	.file	"Main.c"
#NO_APP
	.text
tigcc_compiled.:
#APP
	.xdef _ti89
	.xdef _ti92plus
	.xdef _v200
	.xdef __ref_all___startup_code
	.xdef __ref_all___MIN_AMS_required
	.xdef __ref_all___MIN_AMS_1_01
	.set _A_LINE,0xA000
	.xdef __ref_all___kernel_format_data_var
	.xdef _tigcc_native
	.xdef __ref_all___nostub
	.xdef __ref_all___optimize_rom_calls
	.xdef __ref_all___compressed_format_relocs
	.xdef __ref_all___kernel_format_rom_calls
	.set MT_TEXT,0x8000
	.set MT_XREF,0x9000
	.set MT_ICON,0xA000
	.set MT_CASCADE,0x4000
	
	.data
	.even
	.xdef SetupCharSet
SetupCharSet:
| The method is fast in both cases. Therefore, there is no need to suppress interrupts.

	pea (%a2)
	move.l %d3,-(%sp)
	
	movea.l 0xC8.w,%a2

| A cmpi.w would be enough...
	cmpi.l #1000,-4(%a2)
	bgt.s __Prepare_fonts_AMS_2xx__
__Prepare_fonts_AMS_1xx__:
| Get the address of DrawStr.
	movea.l 0x1A9*4(%a2),%a0
	
| Check if we have an old PedroM version.
	cmpi.l #0x50656472,-(%a0) | 'Pedr', a signature of PedroM.
	bne.s __The_ROM_we_re_running_on_is_not_PedroM__

| We have PedroM.

| Setup all fonts. This will suppress crashes consecutive to the use of a
| font that was not initialized...

| d(pc) mode is forbidden for general purpose code.
	lea __F_8x10_Font__,%a1
	move.l -(%a0),(%a1)
	move.l -(%a0),-(%a1)
	move.l -(%a0),-(%a1)
	bra.s __Prepare_fonts_end__

__The_ROM_we_re_running_on_is_not_PedroM__:
| Retrieving the addresses of the fonts is easy (but slightly nasty) on AMS 1.xx.

| Catch a pc-relative jump to a subroutine in which are the three addresses we're looking for.
	lea 58+4(%a0),%a0 | Get rid of the cmpi.l #0x50656472,-(%a0) above.
	movea.w (%a0),%a1
	adda.l %a0,%a1
| a1 now contains the absolute address of the subroutine.

| d(pc) mode is forbidden for general purpose code.
	lea __FontsTable__,%a0

| Setup all fonts. This will suppress crashes consecutive to the use of a
| font that was not initialized...
| Setup F_4x6
	move.l 122(%a1),(%a0)+
| Setup F_6x8
	move.l 106(%a1),(%a0)+
| Setup F_8x10
	move.l 82(%a1),(%a0)

	bra.s __Prepare_fonts_end__

.even
__Prepare_fonts_AMS_2xx__:
| The fonts can be redefined on AMS 2.xx. So, retrieving the addresses of the fonts must be
| performed with FlashApp functions.

	movea.l 0x45D*4(%a2),%a0 | EV_runningApp
	move.w (%a0),%d3
	beq.s __Prepare_fonts_GetAttr__
| OO_GetAppAttr calls OO_GetAttr with the frame of the given application.
| So we are going to catch the frame of the running application, to pass it
| to OO_CondGetAttr.
| We have AMS 2.xx, we can use ROM_CALL 441 'HeapTable' (smaller and faster
| than pushing d3.w on the stack, calling HeapDeref, correcting sp).
        movea.l 0x441*4(%a2),%a0 | HeapTable
	lsl.w #2,%d3
	movea.l 0(%a0,%d3.w),%a0

| The pFrame of an ACB structure is located 20 bytes after the beginning.
	movea.l 20(%a0),%a0
	
	bra.s _Prepare_fonts_GetAttr__

__Prepare_fonts_GetAttr__:
        lea 0xFF000000.l,%a0
_Prepare_fonts_GetAttr__:
	movea.l 0x3FA*4(%a2),%a2 | OO_CondGetAttr
| We use OO_CondGetAttr because it does not throw errors, unlike OO_GetAttr
| (which can call OO_CondGetAttr anyway).

| Setup all fonts. This will suppress crashes consecutive to the use of a
| font that was not initialized...
| Setup F_4x6
| d(pc) mode is forbidden for general purpose code.
	pea __F_4x6_Font__
	pea 0x300.w
	pea (%a0)

	jsr (%a2)
	tst.w %d0
	beq.s __Prepare_fonts_problem__

| Setup F_6x8
	addq.l #4,8(%sp)
	addq.w #1,6(%sp)
	jsr (%a2)
	tst.w %d0
	beq.s __Prepare_fonts_problem__

| Setup F_8x10
	addq.l #4,8(%sp)
	addq.w #1,6(%sp)
	jsr (%a2)
	tst.w %d0
	beq.s __Prepare_fonts_problem__

	lea 12(%sp),%sp

__Prepare_fonts_end__:
	moveq #1,%d0

_Prepare_fonts_end__:
| Don't forget to restore registers...
	move.l (%sp)+,%d3
	move.l (%sp)+,%a2

| This is not an inlined version of the routine...
	rts

__Prepare_fonts_problem__:
	moveq #0,%d0
	bra.s _Prepare_fonts_end__

	
| The three pointers are always stored into the program. This wastes 8 bytes maximum, but
| increases the speed of some of the functions.
| The pointer to F_4x6 also points to the character widths of F_4x6, due to the way the
| characters are stored.
	.xdef __FontsTable__
	.even
__FontsTable__:
	.xdef __F_4x6_Font__
	.even
__F_4x6_Font__:
	.long 0

	.xdef __F_6x8_Font__
	.even
__F_6x8_Font__:
	.long 0
	
	.xdef __F_8x10_Font__
	.even
__F_8x10_Font__:
	.long 0

	.xdef __ref_all___custom_int_handlers;.text;.even;CLOCK_TIMER:move.w #0x2700,%sr;movem.l %d0-%d7/%a0-%a6,-(%sp);move.l 0xC8,%a5;jbsr __CLOCK_TIMER_body__;movem.l (%sp)+,%d0-%d7/%a0-%a6;rte
#NO_APP
	.text
	.even
	.globl	__CLOCK_TIMER_body__
__CLOCK_TIMER_body__:
	link.w %a6,#0
	move.l clock,%a0
	move.w 6(%a0),%d0
	jbeq .L9
	move.w #0,6(%a0)
	move.w 6(%a0),%d0
	move.w %d0,4(%a0)
	move.w 4(%a0),%d0
	move.w %d0,2(%a0)
	move.w 2(%a0),%d0
	move.w %d0,(%a0)
	jbra .L8
	.even
.L9:
	move.w 8(%a0),%d0
	cmp.w #1,%d0
	jbne .L8
	move.w (%a0),%d0
	addq.w #1,%d0
	move.w %d0,(%a0)
	move.w (%a0),%d0
	cmp.w #18,%d0
	jble .L8
	move.w (%a0),%d0
	add.w #-19,%d0
	move.w %d0,(%a0)
	move.w 2(%a0),%d0
	addq.w #1,%d0
	move.w %d0,2(%a0)
	move.w 2(%a0),%d0
	cmp.w #59,%d0
	jble .L8
	move.w 2(%a0),%d0
	add.w #-60,%d0
	move.w %d0,2(%a0)
	move.w 4(%a0),%d0
	addq.w #1,%d0
	move.w %d0,4(%a0)
.L8:
	unlk %a6
	rts
	.even
	.globl	__main
__main:
	link.w %a6,#-60
	pea -60(%a6)
	move.l 1360(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
	tst.w %d0
	jbne .L14
	jbsr Initialize_Game
	jbsr Show_Title
	jbsr Main_Menu
	move.l 1364(%a5),%a0
	jbsr (%a0)
	jbra .L13
	.even
.L14:
	jbsr LeadOut2
	.even
.L13:
	unlk %a6
	rts
#APP
	
IsVTI:
    trap   #12         /* enter supervisor mode. returns old (%sr) in %d0.w   */
    move.w #0x3000,%sr /* set a non-existing flag in %sr (but keep s-flag !!) */
    swap   %d0         /* save %d0.w content in upper part of %d0             */
    move.w %sr,%d0     /* get %sr content and check for non-existing flag     */
    btst   #12,%d0     /* this non-existing flag can only be set on the VTI   */
    bne    __VTI           
    swap   %d0         /* restore old %sr content and return 0                */
    move.w %d0,%sr
    moveq  #0,%d0
    rts
__VTI:
    swap   %d0         /* restore old %sr content and return 1                */
    move.w %d0,%sr
    moveq  #1,%d0
    rts

#NO_APP
	.text
.LC1:
	.ascii "Warning, Game Speed is Fast on VTI\0"
.LC2:
	.ascii "Error, Not Enough Memory.  Free up RAM\0"
	.text
	.even
Initialize_Game:
	link.w %a6,#0
	move.l %a2,-(%sp)
	move.l 100.w,interrupt1
	move.l 116.w,interrupt5
	move.l #__dummy_handler__,262244
	clr.l Bulk
	clr.l Home
	clr.l Western
	clr.l Eastern
	move.l 1452(%a5),%a0
	jbsr (%a0)
	cmp.w #20,(%a0)
	sls %d0
	ext.w %d0
	neg.w %d0
	move.w %d0,HW1
	jbsr IsVTI
	tst.w %d0
	jbeq .L17
	move.w #1,HW1
	pea .LC1
	move.l 920(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
.L17:
	pea 3840.w
	move.l 648(%a5),%a0
	jbsr (%a0)
	move.l %a0,Home
	addq.l #4,%sp
	jbne .L18
	pea .LC2
	move.l 920(%a5),%a0
	jbsr (%a0)
	jbsr LeadOut
	.even
.L18:
	pea 3840.w
	pea 19456.w
	move.l %a0,-(%sp)
	move.l 2472(%a5),%a0
	jbsr (%a0)
	pea 11846.w
	move.l 648(%a5),%a0
	jbsr (%a0)
	move.l %a0,Bulk
	lea (16,%sp),%sp
	jbne .L19
	subq.l #2,%sp
	clr.b 1(%sp)
	jbsr ERROR
	addq.l #2,%sp
.L19:
	move.l Bulk,Team1
	move.l Bulk,%d0
	move.w #18,%a0
	add.l %d0,%a0
	move.l %a0,Team2
	moveq.l #36,%d1
	add.l %d0,%d1
	move.l %d1,puck
	moveq.l #50,%d2
	add.l %d0,%d2
	move.l %d2,map
	moveq.l #58,%d1
	add.l %d0,%d1
	move.l %d1,game
	moveq.l #78,%d2
	add.l %d0,%d2
	move.l %d2,clock
	moveq.l #90,%d1
	add.l %d0,%d1
	move.l %d1,dbuffer
	move.l %d0,%d1
	add.l #7778,%d1
	move.l %d1,Config
	moveq.l #48,%d2
	add.l %d1,%d2
	move.l %d2,plane
	moveq.l #66,%d2
	add.l %d1,%d2
	move.l %d2,NHLl
	add.l #2067,%d1
	move.l %d1,NHLd
	moveq.l #3,%d1
	move.l %d0,%a2
	move.w #12,%a1
	jbra .L20
	.even
.L24:
	clr.l (%a2,%a1.l)
	clr.l (%a0,%a1.l)
.L20:
	subq.l #4,%a1
	dbra %d1,.L24
	move.l game,%a0
	clr.b 16(%a0)
	move.l game,%a0
	move.b #1,17(%a0)
	move.l game,%a0
	clr.b 18(%a0)
	jbsr Compatibility
	move.l Team1,-(%sp)
	lea Allocate_Players,%a2
	jbsr (%a2)
	move.l Team2,-(%sp)
	jbsr (%a2)
	move.b 6291479,%d0
	clr.l __randseed
	move.b %d0,__randseed+3
	move.l clock,%a0
	move.w #0,8(%a0)
	move.w #1,6(%a0)
	move.l #CLOCK_TIMER,262260
	jbsr Load_Gfx
	jbsr Load_Config
	jbsr Load_Teams
	move.w #1999,-(%sp)
	move.l NHLl,-(%sp)
	move.l RLE_NHLl,-(%sp)
	lea RLE_Decompress,%a2
	jbsr (%a2)
	move.w #1999,-(%sp)
	move.l NHLd,-(%sp)
	move.l RLE_NHLd,-(%sp)
	jbsr (%a2)
	move.l NHLl,%a0
	move.b #-25,1(%a0)
	move.l NHLd,%a0
	move.b #24,1(%a0)
	jbsr SetupCharSet
	lea (28,%sp),%sp
	tst.w %d0
	jbne .L25
	subq.l #2,%sp
	move.b #4,1(%sp)
	jbsr ERROR
	addq.l #2,%sp
.L25:
	jbsr GrayOn
	tst.w %d0
	jbne .L26
	subq.l #2,%sp
	clr.b 1(%sp)
	jbsr ERROR
	addq.l #2,%sp
.L26:
	move.l dbuffer,%d0
	addq.l #7,%d0
	moveq.l #-8,%d2
	and.l %d2,%d0
	clr.w __gray_dbl_offset
	move.l %d0,__D_plane2
	add.l #3840,%d0
	move.l %d0,__L_plane2
	move.l -4(%a6),%a2
	unlk %a6
	rts
	.even
	.globl	Allocate_Players
Allocate_Players:
	link.w %a6,#0
	move.l %a2,-(%sp)
	move.l %d3,-(%sp)
	move.l 8(%a6),%a2
	moveq.l #2,%d3
	jbra .L28
	.even
.L33:
	pea 26.w
	move.l 648(%a5),%a0
	jbsr (%a0)
	move.l %a0,(%a2)+
	addq.l #4,%sp
	jbne .L30
	subq.l #2,%sp
	clr.b 1(%sp)
	jbsr ERROR
	addq.l #2,%sp
.L30:
	subq.w #1,%d3
.L28:
	tst.w %d3
	jbge .L33
	move.l -8(%a6),%d3
	move.l -4(%a6),%a2
	unlk %a6
	rts
	.text
	.even
.LC3:
	.word	11
	.word	7
	.word	94
	.word	60
	.word	58
	.word	100
	.word	40
	.word	41
	.word	20
	.even
.LC4:
	.word	16
	.word	9
	.word	122
	.word	90
	.word	88
	.word	150
	.word	60
	.word	52
	.word	26
	.text
	.even
	.globl	Compatibility
Compatibility:
	link.w %a6,#0
	move.l %d3,-(%sp)
	move.l Config,%a0
	move.w __calculator,%d2
	moveq.l #8,%d0
	tst.w %d2
	jbne .L36
	moveq.l #6,%d0
.L36:
	swap %d0
	clr.w %d0
	and.l #65535,%d1
	or.l %d0,%d1
	moveq.l #6,%d0
	tst.w %d2
	jbne .L38
	clr.w %d0
.L38:
	move.w %d0,%d1
	move.l %d1,(%a0)
	and.l #65535,%d0
	moveq.l #5,%d1
	tst.w %d2
	jbne .L40
	clr.w %d1
.L40:
	move.w %d1,%d0
	move.l %d0,4(%a0)
	and.l #65535,%d0
	moveq.l #4,%d1
	tst.w %d2
	jbne .L42
	moveq.l #1,%d1
.L42:
	move.w %d1,%d0
	move.l %d0,8(%a0)
	and.l #65535,%d0
	moveq.l #7,%d1
	tst.w %d2
	jbne .L44
	moveq.l #2,%d1
.L44:
	move.w %d1,%d0
	move.l %d0,12(%a0)
	and.l #65535,%d0
	moveq.l #6,%d1
	tst.w %d2
	jbne .L46
	moveq.l #3,%d1
.L46:
	move.w %d1,%d0
	move.l %d0,16(%a0)
	moveq.l #7,%d0
	tst.w %d2
	jbne .L48
	moveq.l #5,%d0
.L48:
	swap %d0
	clr.w %d0
	and.l #65535,%d1
	or.l %d0,%d1
	moveq.l #6,%d0
	tst.w %d2
	jbne .L50
	clr.w %d0
.L50:
	move.w %d0,%d1
	move.l %d1,20(%a0)
	moveq.l #4,%d0
	tst.w %d2
	jbeq .L52
	move.l #393220,%d0
	cmp.w #1,%d2
	jbeq .L52
	moveq.l #15,%d0
	tst.w %d2
	jbeq .L62
	clr.w %d0
.L62:
	swap %d0
	clr.w %d0
	and.l #65535,%d1
	or.l %d0,%d1
	moveq.l #3,%d0
	tst.w %d2
	jbne .L64
	moveq.l #15,%d0
.L64:
	move.w %d0,%d1
	move.l %d1,%d0
.L52:
	move.l %d0,24(%a0)
	move.w __calculator,%d2
	moveq.l #5,%d0
	tst.w %d2
	jbeq .L66
	move.l #458756,%d0
	cmp.w #1,%d2
	jbeq .L66
	tst.w %d2
	seq %d0
	ext.w %d0
	addq.w #6,%d0
	swap %d0
	clr.w %d0
	and.l #65535,%d1
	or.l %d0,%d1
	moveq.l #4,%d0
	tst.w %d2
	jbne .L78
	moveq.l #7,%d0
.L78:
	move.w %d0,%d1
	move.l %d1,%d0
.L66:
	move.l %d0,28(%a0)
	move.w __calculator,%d2
	moveq.l #6,%d0
	tst.w %d2
	jbeq .L80
	move.l #262148,%d0
	cmp.w #1,%d2
	jbeq .L80
	moveq.l #9,%d0
	tst.w %d2
	jbne .L88
	moveq.l #15,%d0
.L88:
	swap %d0
	clr.w %d0
	and.l #65535,%d1
	or.l %d0,%d1
	moveq.l #3,%d0
	tst.w %d2
	jbne .L90
	moveq.l #15,%d0
.L90:
	move.w %d0,%d1
	move.l %d1,%d0
.L80:
	move.l %d0,32(%a0)
	move.w __calculator,%d2
	move.l #65543,%d0
	tst.w %d2
	jbeq .L92
	move.l #589828,%d0
	cmp.w #1,%d2
	jbeq .L92
	tst.w %d2
	seq %d0
	ext.w %d0
	moveq.l #2,%d3
	sub.w %d0,%d3
	move.w %d3,%d0
	swap %d0
	clr.w %d0
	and.l #65535,%d1
	or.l %d0,%d1
	moveq.l #4,%d0
	tst.w %d2
	jbne .L106
	moveq.l #7,%d0
.L106:
	move.w %d0,%d1
	move.l %d1,%d0
.L92:
	move.l %d0,36(%a0)
	move.l 24(%a0),40(%a0)
	move.l 2472(%a5),%a0
	tst.w __calculator
	jbne .L107
	pea 18.w
	pea .LC3
	jbra .L109
	.even
.L107:
	pea 18.w
	pea .LC4
.L109:
	move.l plane,-(%sp)
	jbsr (%a0)
	lea (12,%sp),%sp
	move.l -4(%a6),%d3
	unlk %a6
	rts
	.text
.LC5:
	.ascii "Not enough Memory\0"
.LC6:
	.ascii "Hockey needs 80,000 bytes of RAM to run\0"
.LC7:
	.ascii "Link Error\0"
.LC8:
	.ascii "Check Link Connection\0"
.LC9:
	.ascii "Error loading Teams\0"
.LC10:
	.ascii "Make sure hockgfx file is on calc\0"
.LC11:
	.ascii "Error Loading Fonts\0"
.LC12:
	.ascii "Contact phishfud@elknet.net\0"
	.even
Error_Msg.0:
	.long	.LC5
	.long	.LC6
	.long	.LC7
	.long	.LC8
	.long	.LC9
	.long	.LC10
	.long	.LC11
	.long	.LC12
.LC13:
	.ascii "%s\0"
	.text
	.even
	.globl	ERROR
ERROR:
	link.w %a6,#-200
	movm.l #0x1c20,-(%sp)
	move.b 9(%a6),%d5
	tst.w __gray_handle
	jbeq .L111
	tst.l dbuffer
	jbeq .L112
	move.w __gray_dbl_offset,%d1
	jbeq .L113
	move.l __D_plane2,%d0
	jbra .L114
	.even
.L113:
	move.l __D_plane,%d0
.L114:
	move.l %d0,-(%sp)
	tst.w %d1
	jbeq .L115
	move.l __L_plane2,%d0
	jbra .L116
	.even
.L115:
	move.l __L_plane,%d0
.L116:
	move.l %d0,-(%sp)
	jbsr ClearGrayScreen2B
	move.l #15663231,-(%sp)
	tst.w __gray_dbl_offset
	jbeq .L117
	move.l __D_plane2,%d0
	jbra .L118
	.even
.L117:
	move.l __D_plane,%d0
.L118:
	move.l %d0,-(%sp)
	jbra .L151
	.even
.L112:
	move.l __D_plane,-(%sp)
	move.l __L_plane,-(%sp)
	jbsr ClearGrayScreen2B
	move.l #15663231,-(%sp)
	move.l __D_plane,-(%sp)
.L151:
	move.l 1672(%a5),%a0
	jbsr (%a0)
	lea (16,%sp),%sp
	jbra .L120
	.even
.L111:
	move.w #127,-(%sp)
	move.w #239,-(%sp)
	pea 19456.w
	move.l 1672(%a5),%a0
	jbsr (%a0)
	jbsr clrscr
	addq.l #8,%sp
.L120:
	move.w #1,-(%sp)
	move.l 1596(%a5),%a0
	jbsr (%a0)
	addq.l #2,%sp
	clr.l %d4
	move.b %d5,%d4
	lsl.l #3,%d4
	lea (Error_Msg.0),%a0
	move.l (%a0,%d4.l),-(%sp)
	pea .LC13
	move.l %a6,%d3
	add.l #-200,%d3
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jbsr (%a0)
	lea (12,%sp),%sp
	move.w #4,-(%sp)
	move.l %d3,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.l 1700(%a5),%a0
	jbsr (%a0)
	lea (10,%sp),%sp
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jbsr (%a0)
	addq.l #2,%sp
	move.l %d4,%a0
	add.l #Error_Msg.0+4,%a0
	move.l (%a0),-(%sp)
	pea .LC13
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jbsr (%a0)
	lea (12,%sp),%sp
	move.w #4,-(%sp)
	move.l %d3,-(%sp)
	moveq.l #122,%d0
	tst.w __calculator
	jbne .L122
	moveq.l #94,%d0
.L122:
	move.w %d0,-(%sp)
	clr.w -(%sp)
	move.l 1700(%a5),%a0
	jbsr (%a0)
	lea (10,%sp),%sp
	move.l 2356(%a5),%a0
	jbra .L153
	.even
.L145:
	move.l 1676(%a5),%a0
.L153:
	jbsr (%a0)
	move.w #-513,%d0
	tst.w __calculator
	jbne .L128
	moveq.l #-3,%d0
.L128:
	lea _rowread,%a2
	jbsr (%a2)
	move.w __calculator,%d1
	jbeq .L129
	and.w #2,%d0
	jbra .L154
	.even
.L129:
	and.w #1,%d0
.L154:
	tst.w %d0
	jbne .L124
	tst.w %d1
	jbeq .L131
	move.w #-513,%d0
	jbsr (%a2)
	tst.w __calculator
	jbeq .L134
	and.w #2,%d0
	jbra .L155
	.even
.L134:
	and.w #1,%d0
.L155:
	tst.w %d0
	jbne .L124
.L131:
	tst.w __calculator
	jbeq .L136
	moveq.l #-65,%d0
	jbsr _rowread
	and.w #64,%d0
	jbne .L124
.L136:
	move.w #-257,%d0
	tst.w __calculator
	jbne .L142
	moveq.l #-65,%d0
.L142:
	jbsr _rowread
	tst.w __calculator
	jbeq .L143
	and.w #64,%d0
	jbra .L152
	.even
.L143:
	and.w #1,%d0
.L152:
	tst.w %d0
	jbeq .L145
.L124:
	cmp.b #1,%d5
	jbne .L146
	move.w #-257,%d0
	tst.w __calculator
	jbne .L148
	moveq.l #-65,%d0
.L148:
	jbsr _rowread
	tst.w __calculator
	jbeq .L149
	and.w #64,%d0
	jbra .L156
	.even
.L149:
	and.w #1,%d0
.L156:
	tst.w %d0
	jbne .L146
	jbsr Main_Menu
.L146:
	jbsr LeadOut
	nop
	.even
	.globl	LeadOut
LeadOut:
	link.w %a6,#0
	move.l 1364(%a5),%a0
	jbsr (%a0)
	jbsr LeadOut2
	nop
	.text
.LC14:
	.ascii "hockgfx\0"
.LC15:
	.ascii "Hockey 68k v1.06  --By Fisch\0"
	.text
	.even
	.globl	LeadOut2
LeadOut2:
	link.w %a6,#0
	move.l %d4,-(%sp)
	move.l %d3,-(%sp)
	jbsr Save_Config
	move.l game,%a0
	cmp.w #0,%a0
	jbeq .L159
	cmp.b #1,16(%a0)
	jbne .L159
	jbsr Save_Teams
.L159:
	pea .LC14
	jbsr SafeUnlock
	move.l 2360(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
	move.l Western,%d0
	jbeq .L160
	move.l %d0,-(%sp)
	move.l 652(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
.L160:
	move.l Eastern,%d0
	jbeq .L161
	move.l %d0,-(%sp)
	move.l 652(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
.L161:
	tst.l plane
	jbeq .L162
.L163:
	moveq.l #1,%d3
	move.l Config,%a0
	move.w %d3,%d0
	move.w 36(%a0),%d1
	lsl.w %d1,%d0
	not.w %d0
	jbsr _rowread
	move.l Config,%a0
	move.w 38(%a0),%d1
	lsl.w %d1,%d3
	and.w %d3,%d0
	jbne .L163
.L162:
	jbsr GrayOff
	move.l interrupt1,262244
	move.l interrupt5,262260
	tst.l Bulk
	jbeq .L166
	moveq.l #3,%d4
	moveq.l #12,%d3
	jbra .L175
	.even
.L173:
	move.l Team1,%a0
	move.l (%a0,%d3.l),%d0
	jbeq .L171
	move.l %d0,-(%sp)
	move.l 652(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
.L171:
	move.l Team2,%a0
	move.l (%a0,%d3.l),%d0
	jbeq .L175
	move.l %d0,-(%sp)
	move.l 652(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
.L175:
	subq.l #4,%d3
	dbra %d4,.L173
	move.l Bulk,-(%sp)
	move.l 652(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
.L166:
	tst.l Home
	jbeq .L174
#APP
	.xdef __ref_all___set_file_in_use_bit
#NO_APP
	move.l 1536(%a5),%a0
	jbsr (%a0)
	pea 3840.w
	move.l Home,-(%sp)
	pea 19456.w
	move.l 2472(%a5),%a0
	jbsr (%a0)
	pea .LC15
	move.l 920(%a5),%a0
	jbsr (%a0)
	move.l Home,-(%sp)
	move.l 652(%a5),%a0
	jbsr (%a0)
	lea (20,%sp),%sp
.L174:
	jbsr __exit
	nop
.comm Team1,4
.comm Team2,4
.comm puck,4
.comm map,4
.comm game,4
.comm clock,4
.comm plane,4
.comm Config,4
.comm Home,4
.comm Bulk,4
.comm HW1,2
.comm Control_Delay,2
.comm Link,2
.comm Calc,2
.comm Cur_Plr,2
.comm interrupt1,4
.comm interrupt5,4
.comm Hand,4
.comm PlrGfx,4
.comm SkinnyGfx,4
.comm LevelData,4
.comm Blocks,4
.comm Arrows,4
.comm Easternl,4
.comm Easternd,4
.comm Westernl,4
.comm Westernd,4
.comm C_Mask,4
.comm RLE_NHLd,4
.comm RLE_NHLl,4
.comm Flower,4
.comm LinkPlay,4
.comm Font,4
.comm Starting_Pos,4
.comm Default_Western,4
.comm Default_Eastern,4
.comm NHLl,4
.comm NHLd,4
.comm Western,4
.comm Eastern,4
	.text
.LC0:
	.ascii "\0hockgfx\0"
	.text
	.even
Load_Gfx:
	link.w %a6,#0
	move.l %a2,-(%sp)
#APP
	.xdef __ref_all___set_file_in_use_bit
#NO_APP
	move.l 2572(%a5),%a0
	clr.w -(%sp)
	pea .LC0+8
	jbsr (%a0)
	move.l %a0,%a2
	addq.l #6,%sp
	cmp.w #0,%a0
	jbne .L2
	subq.l #2,%sp
	move.b #2,1(%sp)
	jbsr ERROR
	addq.l #2,%sp
.L2:
	move.w 12(%a2),-(%sp)
	move.l 612(%a5),%a0
	jbsr (%a0)
	move.l %a0,Hand
	addq.l #2,%sp
	jbne .L3
	subq.l #2,%sp
	move.b #2,1(%sp)
	jbsr ERROR
	addq.l #2,%sp
.L3:
	move.l Hand,%d0
	move.l %d0,%d1
	addq.l #2,%d1
	move.l %d1,Hand
	moveq.l #66,%d2
	add.l %d0,%d2
	move.l %d2,PlrGfx
	add.l #1472,%d1
	move.l %d1,SkinnyGfx
	add.l #2128,%d2
	move.l %d2,LevelData
	add.l #1126,%d1
	move.l %d1,Blocks
	add.l #6038,%d2
	move.l %d2,Arrows
	add.l #8488,%d0
	move.l %d0,Easternl
	add.l #6116,%d1
	move.l %d1,Easternd
	add.l #228,%d1
	move.l %d1,Westernl
	add.l #228,%d1
	move.l %d1,Westernd
	add.l #228,%d1
	move.l %d1,C_Mask
	add.l #228,%d1
	move.l %d1,Flower
	add.l #192,%d1
	move.l %d1,LinkPlay
	add.l #252,%d1
	move.l %d1,RLE_NHLd
	add.l #1517,%d1
	move.l %d1,RLE_NHLl
	add.l #4857,%d2
	move.l %d2,Font
	add.l #2436,%d1
	move.l %d1,Starting_Pos
	moveq.l #18,%d2
	add.l %d1,%d2
	move.l %d2,Default_Western
	add.l #6915,%d0
	move.l %d0,Default_Eastern
	move.l -4(%a6),%a2
	unlk %a6
	rts
	.even
SafeUnlock:
	link.w %a6,#0
	movm.l #0x1820,-(%sp)
	move.l 8(%a6),%d4
	move.l %d4,-(%sp)
	move.l 2552(%a5),%a0
	jbsr (%a0)
	addq.l #4,%sp
	move.l %d0,%d3
	move.w %d0,%d1
	addq.w #2,%d1
	clr.l %d0
	move.w %d1,%d0
	addq.l #1,%d0
	and.l #131070,%d0
	sub.l %d0,%sp
	move.l %sp,%a2
	clr.b (%sp)
	subq.w #1,%d1
	move.w %d1,-(%sp)
	clr.w -(%sp)
	move.l %d4,-(%sp)
	pea 1(%a2)
	move.l 2472(%a5),%a0
	jbsr (%a0)
	lea (12,%sp),%sp
	and.l #0xFFFF,%d3
	lea 1(%a2,%d3.l),%a2
#APP
	.xdef __ref_all___set_file_in_use_bit
#NO_APP
	move.l 2572(%a5),%a0
	clr.w -(%sp)
	move.l %a2,-(%sp)
	jbsr (%a0)
	addq.l #6,%sp
	cmp.w #0,%a0
	jbeq .L4
	btst #3,11(%a0)
	jbeq .L4
	move.w 12(%a0),%d0
	jbeq .L4
	move.w %d0,-(%sp)
	move.l 636(%a5),%a0
	jbsr (%a0)
.L4:
	movm.l -12(%a6),#0x418
	unlk %a6
	rts
.comm dbuffer,4
